﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="Default.aspx.cs" Inherits="ImgJcrop._Default" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>在线裁剪</title>
    <link href="Scripts/jcrop/jquery.Jcrop.css" rel="stylesheet" type="text/css" />
    <link href="Scripts/uploadify-v3.1/uploadify.css" rel="stylesheet" type="text/css" />
    <script src="Scripts/jquery.1.9.0.min.js" type="text/javascript"></script>
    <script src="Scripts/jcrop/jquery.Jcrop.js" type="text/javascript"></script>
    <script src="Scripts/uploadify-v3.1/jquery.uploadify-3.1.js" type="text/javascript"></script>
    <script type="text/javascript">
        $(function () {
            var jcrop_api, boundx, boundy;

            $("#file_upload").uploadify({
                "auto": true,
                "buttonText": "选择图片",
                "swf": "Scripts/uploadify-v3.1/uploadify.swf",
                "uploader": "App_Handler/Uploadify.ashx?action=upload",
                "fileTypeExts": "*.jpg; *.jpeg; *.gif; *.png; *.bmp",
                "fileTypeDesc": "支持的格式：",
                "multi": false,
                "removeCompleted": false,
                "onUploadStart": function (file) {
                    $("#file_upload-queue").hide();
                },
                "onUploadSuccess": function (file, data, response) {
                    var row = eval("[" + data + "]");
                    if (row[0]["status"] == 0) {
                        $("#cutimg").html("<img id=\"imgOriginal\" name=\"imgOriginal\" /><div style=\"overflow: hidden; margin-top: 20px;\"><div style=\"width: 120px; height: 120px; overflow: hidden;\"><img id=\"imgPreview\" /></div><br /><input type=\"button\" id=\"btnImgCut\" onclick=\"cutSaveImg()\" value=\"裁剪并保存图片\" /></div>");
                        $("#cutimg img").each(function () { $(this).attr("src", row[0]["message"]); });
                        $("#hidImgUrl").val(row[0]["message"]);
                        $('#imgOriginal').Jcrop({
                            onChange: updatePreview,
                            onSelect: updatePreview,
                            aspectRatio: 1,
                            //maxSize: [120, 120],
                            setSelect: [0, 0, 120, 120]
                        }, function () {
                            var bounds = this.getBounds();
                            boundx = bounds[0];
                            boundy = bounds[1];
                            jcrop_api = this;
                        });
                    } else {
                        alert(row[0]["message"]);
                    }
                }
            });

            function updatePreview(c) {

                if (parseInt(c.w) > 0) {
                    var rx = 120 / c.w;
                    var ry = 120 / c.h;

                    $("#imgPreview").css({
                        width: Math.round(rx * boundx) + "px",
                        height: Math.round(ry * boundy) + "px",
                        marginLeft: "-" + Math.round(rx * c.x) + "px",
                        marginTop: "-" + Math.round(ry * c.y) + "px"
                    });
                }
                $("#hidXone").val(c.x);
                $("#hidYone").val(c.y);
                $("#hidXtwo").val(c.hidXtwo);
                $("#hidYtwo").val(c.hidYtwo);
                $("#hidImgWidth").val(c.w);
                $("#hidImgHeight").val(c.h);
            };
        });

        function cutSaveImg() {
            $.ajax({
                type: "post",
                url: "App_Handler/Uploadify.ashx?action=cutsaveimg",
                data: { strImgUrl: $("#imgOriginal")[0].src, hidXone: $("#hidXone").val(), hidYone: $("#hidYone").val(), hidImgWidth: $("#hidImgWidth").val(), hidImgHeight: $("#hidImgHeight").val() },
                dataType: "html",
                success: function (data) {
                    var row = eval("[" + data + "]");
                    if (row[0]["status"] == 0) { }
                    alert(row[0]["message"]);
                }
            });
        }
    </script>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <input type="file" id="file_upload" name="file_upload" />
    </div>
    <div id="cutimg">
    </div>
    <asp:HiddenField ID="hidXone" runat="server" />
    <asp:HiddenField ID="hidYone" runat="server" />
    <asp:HiddenField ID="hidXtwo" runat="server" />
    <asp:HiddenField ID="hidYtwo" runat="server" />
    <asp:HiddenField ID="hidImgWidth" runat="server" />
    <asp:HiddenField ID="hidImgHeight" runat="server" />
    <asp:HiddenField ID="hidImgUrl" runat="server" />
    </form>
</body>
</html>
